var log = console.log;

/*
 *   ->   B -------> G
 * A -> | C --> E -> F
 *      | D -^ 
 * 
 *      H ->
 * F -> IF(rule)
 *      C ->
 * 
 */

    //wait:['A'] reverse blocking

// pre/post triger

var graph = {
  version:'0.0.1',
  nodes: {
    A: {
      type:'series',
      edge:['B', 'CD']
    },
    B: {
      type:'node',
      edge:'G'
    },
    CD: {
      type:'parallel',
      edge:['C','D'],
      end:'E'//??
    },
    C: {
      edge:'E'
    },
    D: {
      edge:'E'
    },
    E: {
      edge:'F'
    },
    F: {
      type:'branch',
      logic: function(next) {next(null,'E');},
      edge:['E','H'],
    },
    G: {
      type:'node'
    },
    /*
    test: {
      edge:['A', {
        TTT: {
          edge:'F'
        }
      }],
    },
  
    test3: {
      edge:{
        TTTD: {
          edge:'B'
        }
      },
    },
    */
  }
}

/*
 * Workflow
 * A->B->C  you edit B func (does it stop all the existing workflow?)
 * each workflow has to have all the function inplace and they are versioned.
 * When running a workflow we use the version.
 * 
 * wf1.js, wf1v2.js, wf1v3.js (the doc will know what version it was working under)
 * it will let the user review and update the workflow if we need to. this is just an update
 * to the version of the doc flow.
 * 
 * ? restart option
 * or a convert function (so if on v1 -> v3) we could run a convert script to upgrade v1 to v3 and let it keep flowing!
 */

function node(id, config) {
  this.id = id;
  this.config = config;
  this._DAG = null,
  this.edge = {};
  this.config.type = this.config.type || 'node';
}

node.prototype = {
  buildDAG:function(lookup) {
    this._DAG = lookup;
    for(var i in this.config.edge) {
      this.edge[this.config.edge[i]] = lookup[this.config.edge[i]];
    }
  },
  find: function(path) {
    if(typeof(path) == 'string') {
      path = path.split('/');
      if(path.length == 1) {
        return this._DAG[path.shift()];
      } else {
        return this._DAG[path.shift()].find(path);
      }
    } else {
      var id = path.shift();
      if(!id) return this;
      if(!this.edge[id]) return null;
      return this.edge[id].find(path);
    }
  }
};

function parseConfig(graph) {
  var lastNode = null;
  var nodes = {};

  function recursivelyAdd(list) {
    for(var i in list) {
      var edge = list[i].edge;
      if(typeof(edge) == 'string') list[i].edge = [edge];
      else if(typeof(edge) == 'object') {
        if(edge.constructor === Array) {
          for(var j in edge) {
            if(typeof(edge[j]) == 'object') {
              recursivelyAdd(edge[j]);
              
              // we need to get the key name for the object
              // we just added because in the current mapping
              // the key is 0 not the key name so we have to loop
              // the object to get its key name
              for(var k in edge[j]) {
                edge[j] = k;
                break;
              }
            }
          }          
        } else {
          recursivelyAdd(edge);
          for(var k in edge) {
            list[i].edge = [k];
            break;
          }
        }
        
      }

      nodes[i] = new node(i, list[i]);
    }
  }

  recursivelyAdd(graph);
  
  for(var i in nodes) {
    nodes[i].buildDAG(nodes);
    lastNode = nodes[i];
  }

  return lastNode;
}

var qqq = parseConfig(graph.nodes);

var lastState = {
  activeNodes: [
    'A'
  ]
}

log(qqq.find('A').edge);
